## About commit messages

Commit messages should follow the [conventional commit specification](https://www.conventionalcommits.org/en/v1.0.0/)
 
The format is: 
```
<type>[(optional scope)]: <description>

[optional body]

[optional footer(s)]
```

The type is one of:
- **fix**: Commit fixes a bug
- **feat**: Commit introduces a new feature
- **refactor**: Commit refactors code
- **perf**: Commit optimizes performance
- **doc**: Commit changes or adds documentation
- **tweak**: Minor changes

A scope may be appended to the type, for example:
`feat(renderer): Implement the good lights`

If a commit introduces a breaking API change, a exclamation point (!) is added after the type:
`feat(renderer)!: New render view api`

Optionally, a breaking change may contain a "BREAKING CHANGE: <description>" footer,
that explains the change.

