#ifndef RT_RENCOM_RENDERER_API_H
#define RT_RENCOM_RENDERER_API_H

#include <runtime/runtime.h>
#include "renderer.h"

typedef struct rt_physical_resource_manager_i rt_physical_resource_manager_i;

typedef rt_physical_resource_manager_i rt_render_device_get_physical_resource_manager_fn(void *o);

/* Interface for the render device.
 * The device is responsible for executing command lists. */
typedef struct {
    void *o;
    rt_render_device_get_physical_resource_manager_fn *GetPhysicalResourceManager;
} rt_render_device_i;

/* Interface for the physical resource manager.
 * The physical resource manager maps render resources to actual gpu memory (=api objects like VkImage)
 */
struct rt_physical_resource_manager_i {
    void *o;
};

typedef struct {
    rt_result result;
    rt_render_device_i device;
} rt_render_backend_init_result;

typedef void rt_render_backend_register_cvars_fn(void);
typedef rt_render_backend_init_result rt_render_backend_init_fn(const rt_renderer_window_info *info);
typedef void rt_render_backend_shutdown_fn(void);

/* Public renderer interface */
typedef struct {
    rt_render_backend_register_cvars_fn *RegisterCVARs;
    rt_render_backend_init_fn *Init;
    rt_render_backend_shutdown_fn *Shutdown;
} rt_render_backend_api;

extern rt_render_backend_api g_render_backend;

#endif
